"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Method = exports.Tags = exports.Controller = exports.CONTROLLER_PATH_PROP = exports.metadataKey = void 0;
require("reflect-metadata");
exports.metadataKey = Symbol('Method');
exports.CONTROLLER_PATH_PROP = '__CONTROLLER_PATH__';
function Controller(path) {
    return function Controller(target) {
        target.prototype[exports.CONTROLLER_PATH_PROP] = path;
    };
}
exports.Controller = Controller;
function Tags(..._args) {
    return function doNothing() { };
}
exports.Tags = Tags;
function Method(method, path) {
    return function validate(target, propertyKey) {
        registerProperty(target, { path: path || '', method, propertyKey });
    };
}
exports.Method = Method;
function registerProperty(target, meta) {
    const properties = Reflect.getMetadata(exports.metadataKey, target) || [];
    properties.push(meta);
    Reflect.defineMetadata(exports.metadataKey, properties, target);
}
